# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rapid_pbd_msgs/Action.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import trajectory_msgs.msg
import control_msgs.msg
import geometry_msgs.msg
import moveit_msgs.msg
import rapid_pbd_msgs.msg
import genpy
import std_msgs.msg

class Action(genpy.Message):
  _md5sum = "506925add5319b43259a492b55cda211"
  _type = "rapid_pbd_msgs/Action"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Type of the Action
## The first set of actions are actuations that move some part of the robot.
# Open or close one of the grippers
string ACTUATE_GRIPPER = actuate gripper
# Move the head, torso, or arm
string MOVE_TO_JOINT_GOAL = move to joint goal
# Move the arm
string MOVE_TO_CARTESIAN_GOAL = move to cartesian goal

## The second set of actions are perception actions that update the world representation.
# Find tabletop objects
string DETECT_TABLETOP_OBJECTS = detect tabletop objects
# Find a custom landmark
string FIND_CUSTOM_LANDMARK = find custom landmark

string type

# If this is an actuation, this specifies what is being moved.
# Used for robots that only have one gripper
string GRIPPER = gripper
string LEFT_GRIPPER = left gripper
string RIGHT_GRIPPER = right gripper
string HEAD = head
string TORSO = torso
string ARM = arm
string LEFT_ARM = left arm
string RIGHT_ARM = right arm
string actuator_group

# Acutation specifications
## If type == ACTUATE_GRIPPER
control_msgs/GripperCommand gripper_command 

## If type == MOVE_TO_JOINT_GOAL
## Used to move the head, torso, arm, or a custom set of joints
## If the type is MOVE_TO_CARTESIAN_GOAL, this may also specify a seed set of joint angles.
trajectory_msgs/JointTrajectory joint_trajectory

## If type == MOVE_TO_CARTESIAN_GOAL
## This is used for pointing the head or moving the end-effector
geometry_msgs/Pose pose
Landmark landmark # A landmark that acts as the parent frame of the pose

## Specifies the kind of control to use for actuating the arm
ControlStrategy control_strategy

# Perception specifications
## If type == FIND_CUSTOM_LANDMARK
string custom_landmark_name

================================================================================
MSG: control_msgs/GripperCommand
float64 position
float64 max_effort

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rapid_pbd_msgs/Landmark
# Type of the landmark
# A TF frame ID
string TF_FRAME = tf frame
# A box from the tabletop object detector
string SURFACE_BOX = surface box
# A custom landmark
string CUSTOM_LANDMARK = custom landmark
# An AR tag or tag bundle
string AR_TAG = AR tag
string type

# Specifies the pose of the landmark.
# All landmarks and end-effector poses should be specified in the base frame so that
# an end-effector pose can always be transformed into the frame of a different landmark.
# This field can be blank if the landmark's pose is unknown at the time.
geometry_msgs/PoseStamped pose_stamped

# If type == TF_FRAME, name is the frame ID
# If type == SURFACE_BOX, name is an arbitrary name like "Object 1"
# If type == CUSTOM_LANDMARK, name is the name of the custom landmark
string name
geometry_msgs/Vector3 surface_box_dims # Dimensions of a tabletop box
uint32 ar_tag_id # The AR tag ID or master tag ID

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: rapid_pbd_msgs/ControlStrategy
# Position controller, avoids obstacles and moves at a fixed speed.
string DEFAULT_POSITION = default position
# Moves slower when close to obstacles, faster otherwise. Allows contact with obstacles.
string OBSTACLE_SLOWDOWN = obstacle slowdown
string type

float64 max_speed # Maximum speed of the end-effector in the default controller
float64 max_force # Stops the arm if detected contact force exceeds this threshold
moveit_msgs/OrientationConstraint orientation_constraint

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
"""
  # Pseudo-constants
  ACTUATE_GRIPPER = 'actuate gripper'
  MOVE_TO_JOINT_GOAL = 'move to joint goal'
  MOVE_TO_CARTESIAN_GOAL = 'move to cartesian goal'
  DETECT_TABLETOP_OBJECTS = 'detect tabletop objects'
  FIND_CUSTOM_LANDMARK = 'find custom landmark'
  GRIPPER = 'gripper'
  LEFT_GRIPPER = 'left gripper'
  RIGHT_GRIPPER = 'right gripper'
  HEAD = 'head'
  TORSO = 'torso'
  ARM = 'arm'
  LEFT_ARM = 'left arm'
  RIGHT_ARM = 'right arm'

  __slots__ = ['type','actuator_group','gripper_command','joint_trajectory','pose','landmark','control_strategy','custom_landmark_name']
  _slot_types = ['string','string','control_msgs/GripperCommand','trajectory_msgs/JointTrajectory','geometry_msgs/Pose','rapid_pbd_msgs/Landmark','rapid_pbd_msgs/ControlStrategy','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       type,actuator_group,gripper_command,joint_trajectory,pose,landmark,control_strategy,custom_landmark_name

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Action, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = ''
      if self.actuator_group is None:
        self.actuator_group = ''
      if self.gripper_command is None:
        self.gripper_command = control_msgs.msg.GripperCommand()
      if self.joint_trajectory is None:
        self.joint_trajectory = trajectory_msgs.msg.JointTrajectory()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.landmark is None:
        self.landmark = rapid_pbd_msgs.msg.Landmark()
      if self.control_strategy is None:
        self.control_strategy = rapid_pbd_msgs.msg.ControlStrategy()
      if self.custom_landmark_name is None:
        self.custom_landmark_name = ''
    else:
      self.type = ''
      self.actuator_group = ''
      self.gripper_command = control_msgs.msg.GripperCommand()
      self.joint_trajectory = trajectory_msgs.msg.JointTrajectory()
      self.pose = geometry_msgs.msg.Pose()
      self.landmark = rapid_pbd_msgs.msg.Landmark()
      self.control_strategy = rapid_pbd_msgs.msg.ControlStrategy()
      self.custom_landmark_name = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.actuator_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.gripper_command.position, _x.gripper_command.max_effort, _x.joint_trajectory.header.seq, _x.joint_trajectory.header.stamp.secs, _x.joint_trajectory.header.stamp.nsecs))
      _x = self.joint_trajectory.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.joint_trajectory.joint_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_trajectory.joint_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.joint_trajectory.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_trajectory.points:
        length = len(val1.positions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.positions))
        length = len(val1.velocities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocities))
        length = len(val1.accelerations)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.accelerations))
        length = len(val1.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.effort))
        _v1 = val1.time_from_start
        _x = _v1
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_7d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      _x = self.landmark.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.landmark.pose_stamped.header.seq, _x.landmark.pose_stamped.header.stamp.secs, _x.landmark.pose_stamped.header.stamp.nsecs))
      _x = self.landmark.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.landmark.pose_stamped.pose.position.x, _x.landmark.pose_stamped.pose.position.y, _x.landmark.pose_stamped.pose.position.z, _x.landmark.pose_stamped.pose.orientation.x, _x.landmark.pose_stamped.pose.orientation.y, _x.landmark.pose_stamped.pose.orientation.z, _x.landmark.pose_stamped.pose.orientation.w))
      _x = self.landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3dI.pack(_x.landmark.surface_box_dims.x, _x.landmark.surface_box_dims.y, _x.landmark.surface_box_dims.z, _x.landmark.ar_tag_id))
      _x = self.control_strategy.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.control_strategy.max_speed, _x.control_strategy.max_force, _x.control_strategy.orientation_constraint.header.seq, _x.control_strategy.orientation_constraint.header.stamp.secs, _x.control_strategy.orientation_constraint.header.stamp.nsecs))
      _x = self.control_strategy.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.control_strategy.orientation_constraint.orientation.x, _x.control_strategy.orientation_constraint.orientation.y, _x.control_strategy.orientation_constraint.orientation.z, _x.control_strategy.orientation_constraint.orientation.w))
      _x = self.control_strategy.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.control_strategy.orientation_constraint.weight))
      _x = self.custom_landmark_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.gripper_command is None:
        self.gripper_command = control_msgs.msg.GripperCommand()
      if self.joint_trajectory is None:
        self.joint_trajectory = trajectory_msgs.msg.JointTrajectory()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.landmark is None:
        self.landmark = rapid_pbd_msgs.msg.Landmark()
      if self.control_strategy is None:
        self.control_strategy = rapid_pbd_msgs.msg.ControlStrategy()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.actuator_group = str[start:end].decode('utf-8')
      else:
        self.actuator_group = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.gripper_command.position, _x.gripper_command.max_effort, _x.joint_trajectory.header.seq, _x.joint_trajectory.header.stamp.secs, _x.joint_trajectory.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_trajectory.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.joint_trajectory.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_trajectory.joint_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.joint_trajectory.joint_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_trajectory.points = []
      for i in range(0, length):
        val1 = trajectory_msgs.msg.JointTrajectoryPoint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.positions = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.accelerations = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = struct.unpack(pattern, str[start:end])
        _v2 = val1.time_from_start
        _x = _v2
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.joint_trajectory.points.append(val1)
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.type = str[start:end].decode('utf-8')
      else:
        self.landmark.type = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.landmark.pose_stamped.header.seq, _x.landmark.pose_stamped.header.stamp.secs, _x.landmark.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.landmark.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.landmark.pose_stamped.pose.position.x, _x.landmark.pose_stamped.pose.position.y, _x.landmark.pose_stamped.pose.position.z, _x.landmark.pose_stamped.pose.orientation.x, _x.landmark.pose_stamped.pose.orientation.y, _x.landmark.pose_stamped.pose.orientation.z, _x.landmark.pose_stamped.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.name = str[start:end].decode('utf-8')
      else:
        self.landmark.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.landmark.surface_box_dims.x, _x.landmark.surface_box_dims.y, _x.landmark.surface_box_dims.z, _x.landmark.ar_tag_id,) = _struct_3dI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.type = str[start:end].decode('utf-8')
      else:
        self.control_strategy.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.control_strategy.max_speed, _x.control_strategy.max_force, _x.control_strategy.orientation_constraint.header.seq, _x.control_strategy.orientation_constraint.header.stamp.secs, _x.control_strategy.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.control_strategy.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.control_strategy.orientation_constraint.orientation.x, _x.control_strategy.orientation_constraint.orientation.y, _x.control_strategy.orientation_constraint.orientation.z, _x.control_strategy.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.control_strategy.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.control_strategy.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.custom_landmark_name = str[start:end].decode('utf-8')
      else:
        self.custom_landmark_name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.actuator_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.gripper_command.position, _x.gripper_command.max_effort, _x.joint_trajectory.header.seq, _x.joint_trajectory.header.stamp.secs, _x.joint_trajectory.header.stamp.nsecs))
      _x = self.joint_trajectory.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.joint_trajectory.joint_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_trajectory.joint_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.joint_trajectory.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_trajectory.points:
        length = len(val1.positions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.positions.tostring())
        length = len(val1.velocities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.velocities.tostring())
        length = len(val1.accelerations)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.accelerations.tostring())
        length = len(val1.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.effort.tostring())
        _v3 = val1.time_from_start
        _x = _v3
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_7d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      _x = self.landmark.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.landmark.pose_stamped.header.seq, _x.landmark.pose_stamped.header.stamp.secs, _x.landmark.pose_stamped.header.stamp.nsecs))
      _x = self.landmark.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.landmark.pose_stamped.pose.position.x, _x.landmark.pose_stamped.pose.position.y, _x.landmark.pose_stamped.pose.position.z, _x.landmark.pose_stamped.pose.orientation.x, _x.landmark.pose_stamped.pose.orientation.y, _x.landmark.pose_stamped.pose.orientation.z, _x.landmark.pose_stamped.pose.orientation.w))
      _x = self.landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3dI.pack(_x.landmark.surface_box_dims.x, _x.landmark.surface_box_dims.y, _x.landmark.surface_box_dims.z, _x.landmark.ar_tag_id))
      _x = self.control_strategy.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.control_strategy.max_speed, _x.control_strategy.max_force, _x.control_strategy.orientation_constraint.header.seq, _x.control_strategy.orientation_constraint.header.stamp.secs, _x.control_strategy.orientation_constraint.header.stamp.nsecs))
      _x = self.control_strategy.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.control_strategy.orientation_constraint.orientation.x, _x.control_strategy.orientation_constraint.orientation.y, _x.control_strategy.orientation_constraint.orientation.z, _x.control_strategy.orientation_constraint.orientation.w))
      _x = self.control_strategy.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.control_strategy.orientation_constraint.weight))
      _x = self.custom_landmark_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.gripper_command is None:
        self.gripper_command = control_msgs.msg.GripperCommand()
      if self.joint_trajectory is None:
        self.joint_trajectory = trajectory_msgs.msg.JointTrajectory()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.landmark is None:
        self.landmark = rapid_pbd_msgs.msg.Landmark()
      if self.control_strategy is None:
        self.control_strategy = rapid_pbd_msgs.msg.ControlStrategy()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.actuator_group = str[start:end].decode('utf-8')
      else:
        self.actuator_group = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.gripper_command.position, _x.gripper_command.max_effort, _x.joint_trajectory.header.seq, _x.joint_trajectory.header.stamp.secs, _x.joint_trajectory.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_trajectory.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.joint_trajectory.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_trajectory.joint_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.joint_trajectory.joint_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_trajectory.points = []
      for i in range(0, length):
        val1 = trajectory_msgs.msg.JointTrajectoryPoint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.positions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.accelerations = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v4 = val1.time_from_start
        _x = _v4
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.joint_trajectory.points.append(val1)
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.type = str[start:end].decode('utf-8')
      else:
        self.landmark.type = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.landmark.pose_stamped.header.seq, _x.landmark.pose_stamped.header.stamp.secs, _x.landmark.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.landmark.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.landmark.pose_stamped.pose.position.x, _x.landmark.pose_stamped.pose.position.y, _x.landmark.pose_stamped.pose.position.z, _x.landmark.pose_stamped.pose.orientation.x, _x.landmark.pose_stamped.pose.orientation.y, _x.landmark.pose_stamped.pose.orientation.z, _x.landmark.pose_stamped.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.landmark.name = str[start:end].decode('utf-8')
      else:
        self.landmark.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.landmark.surface_box_dims.x, _x.landmark.surface_box_dims.y, _x.landmark.surface_box_dims.z, _x.landmark.ar_tag_id,) = _struct_3dI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.type = str[start:end].decode('utf-8')
      else:
        self.control_strategy.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.control_strategy.max_speed, _x.control_strategy.max_force, _x.control_strategy.orientation_constraint.header.seq, _x.control_strategy.orientation_constraint.header.stamp.secs, _x.control_strategy.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.control_strategy.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.control_strategy.orientation_constraint.orientation.x, _x.control_strategy.orientation_constraint.orientation.y, _x.control_strategy.orientation_constraint.orientation.z, _x.control_strategy.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.control_strategy.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.control_strategy.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.control_strategy.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.custom_landmark_name = str[start:end].decode('utf-8')
      else:
        self.custom_landmark_name = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d3I = struct.Struct("<2d3I")
_struct_7d = struct.Struct("<7d")
_struct_3dI = struct.Struct("<3dI")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_2i = struct.Struct("<2i")
