# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rapid_pbd_msgs/EditorEvent.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import trajectory_msgs.msg
import control_msgs.msg
import sensor_msgs.msg
import geometry_msgs.msg
import moveit_msgs.msg
import rapid_pbd_msgs.msg
import genpy
import std_msgs.msg

class EditorEvent(genpy.Message):
  _md5sum = "c1090b150e67d9f9299c9514f4a98023"
  _type = "rapid_pbd_msgs/EditorEvent"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Specifies an action taken by the PbD editor.

# Used to update detailed fields of a program, not the structure itself
string UPDATE = update program
string DELETE = delete program

# Manipulating the program structure
string ADD_STEP = add step
string DELETE_STEP = delete step
string ADD_ACTION = add action
string DELETE_ACTION = delete action

# Updating the visualization for a program
string VIEW_STEP = view step

# Robot actions to execute
string DETECT_SURFACE_OBJECTS = detect surface objects
string GET_JOINT_VALUES = get joint values
string GET_POSE = get pose

string type

# If type is UPDATE, all fields of program_info and program are needed.
# If type is DELETE, only program_info.db_id is needed.
# If type is ADD_STEP, only program_info.db_id is needed.
# If type is DELETE_STEP, program_info.db_id and step_num are needed
# If type is ADD_ACTION, program_info.db_id, step_num, and action are needed
# If type is DELETE_ACTION, program_info.db_id, step_num, and action_num are needed.
# If type is VIEW, then program_info.db_id and step_num are needed.
# If type is DETECT_SURFACE_OBJECTS, program_info.db_id, step_num, and action_num are needed.
# If type is GET_JOINT_VALUES, program_info.db_id, step_num, action_num, and action.actuator_group are needed.
# If type is GET_POSE, program_info.db_id, step_num, action_num, action.actuator_group, and action.landmark are needed.
rapid_pbd_msgs/ProgramInfo program_info
rapid_pbd_msgs/Program program
int32 step_num # 0-indexed step number
rapid_pbd_msgs/Action action
int32 action_num # 0-indexed action number

================================================================================
MSG: rapid_pbd_msgs/ProgramInfo
# Short meta-information about a program.
string db_id # ID that can be used to reference the program in a database.
string name # Name of the program

================================================================================
MSG: rapid_pbd_msgs/Program
string name # The name of the program.
Step[] steps # The sequence of steps to execute in this program.

# The joint state when the program was created.
# This is used only for visualization purposes, not for specifying the program.
# It allows the interface to render a preview of the robot state for each step.
sensor_msgs/JointState start_joint_state

================================================================================
MSG: rapid_pbd_msgs/Step
Action[] actions # A list of actions to run concurrently.

string scene_id # An ID that can be used to look up a point cloud of the scene at this step.

# All of the landmarks found once this step executes.
#
# When a step is created or edited, this is filled in as perception actions get added
# to the step or existing perception actions are updated.
# Subsequent steps that are created or edited will search backwards to find needed
# landmarks.
#
# When a step is executed, the perception actions are re-run. The program executor
# maintains the world state (aka list of landmarks) in memory.
rapid_pbd_msgs/Landmark[] landmarks # All of the landmarks known at this step.

================================================================================
MSG: rapid_pbd_msgs/Action
# Type of the Action
## The first set of actions are actuations that move some part of the robot.
# Open or close one of the grippers
string ACTUATE_GRIPPER = actuate gripper
# Move the head, torso, or arm
string MOVE_TO_JOINT_GOAL = move to joint goal
# Move the arm
string MOVE_TO_CARTESIAN_GOAL = move to cartesian goal

## The second set of actions are perception actions that update the world representation.
# Find tabletop objects
string DETECT_TABLETOP_OBJECTS = detect tabletop objects
# Find a custom landmark
string FIND_CUSTOM_LANDMARK = find custom landmark

string type

# If this is an actuation, this specifies what is being moved.
# Used for robots that only have one gripper
string GRIPPER = gripper
string LEFT_GRIPPER = left gripper
string RIGHT_GRIPPER = right gripper
string HEAD = head
string TORSO = torso
string ARM = arm
string LEFT_ARM = left arm
string RIGHT_ARM = right arm
string actuator_group

# Acutation specifications
## If type == ACTUATE_GRIPPER
control_msgs/GripperCommand gripper_command 

## If type == MOVE_TO_JOINT_GOAL
## Used to move the head, torso, arm, or a custom set of joints
## If the type is MOVE_TO_CARTESIAN_GOAL, this may also specify a seed set of joint angles.
trajectory_msgs/JointTrajectory joint_trajectory

## If type == MOVE_TO_CARTESIAN_GOAL
## This is used for pointing the head or moving the end-effector
geometry_msgs/Pose pose
Landmark landmark # A landmark that acts as the parent frame of the pose

## Specifies the kind of control to use for actuating the arm
ControlStrategy control_strategy

# Perception specifications
## If type == FIND_CUSTOM_LANDMARK
string custom_landmark_name

================================================================================
MSG: control_msgs/GripperCommand
float64 position
float64 max_effort

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rapid_pbd_msgs/Landmark
# Type of the landmark
# A TF frame ID
string TF_FRAME = tf frame
# A box from the tabletop object detector
string SURFACE_BOX = surface box
# A custom landmark
string CUSTOM_LANDMARK = custom landmark
# An AR tag or tag bundle
string AR_TAG = AR tag
string type

# Specifies the pose of the landmark.
# All landmarks and end-effector poses should be specified in the base frame so that
# an end-effector pose can always be transformed into the frame of a different landmark.
# This field can be blank if the landmark's pose is unknown at the time.
geometry_msgs/PoseStamped pose_stamped

# If type == TF_FRAME, name is the frame ID
# If type == SURFACE_BOX, name is an arbitrary name like "Object 1"
# If type == CUSTOM_LANDMARK, name is the name of the custom landmark
string name
geometry_msgs/Vector3 surface_box_dims # Dimensions of a tabletop box
uint32 ar_tag_id # The AR tag ID or master tag ID

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: rapid_pbd_msgs/ControlStrategy
# Position controller, avoids obstacles and moves at a fixed speed.
string DEFAULT_POSITION = default position
# Moves slower when close to obstacles, faster otherwise. Allows contact with obstacles.
string OBSTACLE_SLOWDOWN = obstacle slowdown
string type

float64 max_speed # Maximum speed of the end-effector in the default controller
float64 max_force # Stops the arm if detected contact force exceeds this threshold
moveit_msgs/OrientationConstraint orientation_constraint

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort
"""
  # Pseudo-constants
  UPDATE = 'update program'
  DELETE = 'delete program'
  ADD_STEP = 'add step'
  DELETE_STEP = 'delete step'
  ADD_ACTION = 'add action'
  DELETE_ACTION = 'delete action'
  VIEW_STEP = 'view step'
  DETECT_SURFACE_OBJECTS = 'detect surface objects'
  GET_JOINT_VALUES = 'get joint values'
  GET_POSE = 'get pose'

  __slots__ = ['type','program_info','program','step_num','action','action_num']
  _slot_types = ['string','rapid_pbd_msgs/ProgramInfo','rapid_pbd_msgs/Program','int32','rapid_pbd_msgs/Action','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       type,program_info,program,step_num,action,action_num

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EditorEvent, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = ''
      if self.program_info is None:
        self.program_info = rapid_pbd_msgs.msg.ProgramInfo()
      if self.program is None:
        self.program = rapid_pbd_msgs.msg.Program()
      if self.step_num is None:
        self.step_num = 0
      if self.action is None:
        self.action = rapid_pbd_msgs.msg.Action()
      if self.action_num is None:
        self.action_num = 0
    else:
      self.type = ''
      self.program_info = rapid_pbd_msgs.msg.ProgramInfo()
      self.program = rapid_pbd_msgs.msg.Program()
      self.step_num = 0
      self.action = rapid_pbd_msgs.msg.Action()
      self.action_num = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program_info.db_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program_info.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.program.steps)
      buff.write(_struct_I.pack(length))
      for val1 in self.program.steps:
        length = len(val1.actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.actions:
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.actuator_group
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v1 = val2.gripper_command
          _x = _v1
          buff.write(_struct_2d.pack(_x.position, _x.max_effort))
          _v2 = val2.joint_trajectory
          _v3 = _v2.header
          buff.write(_struct_I.pack(_v3.seq))
          _v4 = _v3.stamp
          _x = _v4
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v3.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v2.joint_names)
          buff.write(_struct_I.pack(length))
          for val4 in _v2.joint_names:
            length = len(val4)
            if python3 or type(val4) == unicode:
              val4 = val4.encode('utf-8')
              length = len(val4)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val4))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val4))
          length = len(_v2.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v2.points:
            length = len(val4.positions)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.positions))
            length = len(val4.velocities)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.velocities))
            length = len(val4.accelerations)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.accelerations))
            length = len(val4.effort)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.effort))
            _v5 = val4.time_from_start
            _x = _v5
            buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
          _v6 = val2.pose
          _v7 = _v6.position
          _x = _v7
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v8 = _v6.orientation
          _x = _v8
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v9 = val2.landmark
          _x = _v9.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v10 = _v9.pose_stamped
          _v11 = _v10.header
          buff.write(_struct_I.pack(_v11.seq))
          _v12 = _v11.stamp
          _x = _v12
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v11.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v13 = _v10.pose
          _v14 = _v13.position
          _x = _v14
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v15 = _v13.orientation
          _x = _v15
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = _v9.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v16 = _v9.surface_box_dims
          _x = _v16
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_I.pack(_v9.ar_tag_id))
          _v17 = val2.control_strategy
          _x = _v17.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v17
          buff.write(_struct_2d.pack(_x.max_speed, _x.max_force))
          _v18 = _v17.orientation_constraint
          _v19 = _v18.header
          buff.write(_struct_I.pack(_v19.seq))
          _v20 = _v19.stamp
          _x = _v20
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v19.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v21 = _v18.orientation
          _x = _v21
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = _v18.link_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v18
          buff.write(_struct_4d.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
          _x = val2.custom_landmark_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.scene_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.landmarks)
        buff.write(_struct_I.pack(length))
        for val2 in val1.landmarks:
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v22 = val2.pose_stamped
          _v23 = _v22.header
          buff.write(_struct_I.pack(_v23.seq))
          _v24 = _v23.stamp
          _x = _v24
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v23.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v25 = _v22.pose
          _v26 = _v25.position
          _x = _v26
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v27 = _v25.orientation
          _x = _v27
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v28 = val2.surface_box_dims
          _x = _v28
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_I.pack(val2.ar_tag_id))
      _x = self
      buff.write(_struct_3I.pack(_x.program.start_joint_state.header.seq, _x.program.start_joint_state.header.stamp.secs, _x.program.start_joint_state.header.stamp.nsecs))
      _x = self.program.start_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.program.start_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.program.start_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.program.start_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.program.start_joint_state.position))
      length = len(self.program.start_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.program.start_joint_state.velocity))
      length = len(self.program.start_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.program.start_joint_state.effort))
      buff.write(_struct_i.pack(self.step_num))
      _x = self.action.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action.actuator_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.action.gripper_command.position, _x.action.gripper_command.max_effort, _x.action.joint_trajectory.header.seq, _x.action.joint_trajectory.header.stamp.secs, _x.action.joint_trajectory.header.stamp.nsecs))
      _x = self.action.joint_trajectory.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action.joint_trajectory.joint_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.action.joint_trajectory.joint_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.action.joint_trajectory.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.action.joint_trajectory.points:
        length = len(val1.positions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.positions))
        length = len(val1.velocities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocities))
        length = len(val1.accelerations)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.accelerations))
        length = len(val1.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.effort))
        _v29 = val1.time_from_start
        _x = _v29
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_7d.pack(_x.action.pose.position.x, _x.action.pose.position.y, _x.action.pose.position.z, _x.action.pose.orientation.x, _x.action.pose.orientation.y, _x.action.pose.orientation.z, _x.action.pose.orientation.w))
      _x = self.action.landmark.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action.landmark.pose_stamped.header.seq, _x.action.landmark.pose_stamped.header.stamp.secs, _x.action.landmark.pose_stamped.header.stamp.nsecs))
      _x = self.action.landmark.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.action.landmark.pose_stamped.pose.position.x, _x.action.landmark.pose_stamped.pose.position.y, _x.action.landmark.pose_stamped.pose.position.z, _x.action.landmark.pose_stamped.pose.orientation.x, _x.action.landmark.pose_stamped.pose.orientation.y, _x.action.landmark.pose_stamped.pose.orientation.z, _x.action.landmark.pose_stamped.pose.orientation.w))
      _x = self.action.landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3dI.pack(_x.action.landmark.surface_box_dims.x, _x.action.landmark.surface_box_dims.y, _x.action.landmark.surface_box_dims.z, _x.action.landmark.ar_tag_id))
      _x = self.action.control_strategy.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.action.control_strategy.max_speed, _x.action.control_strategy.max_force, _x.action.control_strategy.orientation_constraint.header.seq, _x.action.control_strategy.orientation_constraint.header.stamp.secs, _x.action.control_strategy.orientation_constraint.header.stamp.nsecs))
      _x = self.action.control_strategy.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.action.control_strategy.orientation_constraint.orientation.x, _x.action.control_strategy.orientation_constraint.orientation.y, _x.action.control_strategy.orientation_constraint.orientation.z, _x.action.control_strategy.orientation_constraint.orientation.w))
      _x = self.action.control_strategy.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.action.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.action.control_strategy.orientation_constraint.weight))
      _x = self.action.custom_landmark_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_i.pack(self.action_num))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.program_info is None:
        self.program_info = rapid_pbd_msgs.msg.ProgramInfo()
      if self.program is None:
        self.program = rapid_pbd_msgs.msg.Program()
      if self.action is None:
        self.action = rapid_pbd_msgs.msg.Action()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program_info.db_id = str[start:end].decode('utf-8')
      else:
        self.program_info.db_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program_info.name = str[start:end].decode('utf-8')
      else:
        self.program_info.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program.name = str[start:end].decode('utf-8')
      else:
        self.program.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.program.steps = []
      for i in range(0, length):
        val1 = rapid_pbd_msgs.msg.Step()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.actions = []
        for i in range(0, length):
          val2 = rapid_pbd_msgs.msg.Action()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.actuator_group = str[start:end].decode('utf-8')
          else:
            val2.actuator_group = str[start:end]
          _v30 = val2.gripper_command
          _x = _v30
          start = end
          end += 16
          (_x.position, _x.max_effort,) = _struct_2d.unpack(str[start:end])
          _v31 = val2.joint_trajectory
          _v32 = _v31.header
          start = end
          end += 4
          (_v32.seq,) = _struct_I.unpack(str[start:end])
          _v33 = _v32.stamp
          _x = _v33
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v32.frame_id = str[start:end].decode('utf-8')
          else:
            _v32.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v31.joint_names = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4 = str[start:end].decode('utf-8')
            else:
              val4 = str[start:end]
            _v31.joint_names.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v31.points = []
          for i in range(0, length):
            val4 = trajectory_msgs.msg.JointTrajectoryPoint()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.positions = struct.unpack(pattern, str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.velocities = struct.unpack(pattern, str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.accelerations = struct.unpack(pattern, str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.effort = struct.unpack(pattern, str[start:end])
            _v34 = val4.time_from_start
            _x = _v34
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
            _v31.points.append(val4)
          _v35 = val2.pose
          _v36 = _v35.position
          _x = _v36
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v37 = _v35.orientation
          _x = _v37
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v38 = val2.landmark
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v38.type = str[start:end].decode('utf-8')
          else:
            _v38.type = str[start:end]
          _v39 = _v38.pose_stamped
          _v40 = _v39.header
          start = end
          end += 4
          (_v40.seq,) = _struct_I.unpack(str[start:end])
          _v41 = _v40.stamp
          _x = _v41
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v40.frame_id = str[start:end].decode('utf-8')
          else:
            _v40.frame_id = str[start:end]
          _v42 = _v39.pose
          _v43 = _v42.position
          _x = _v43
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v44 = _v42.orientation
          _x = _v44
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v38.name = str[start:end].decode('utf-8')
          else:
            _v38.name = str[start:end]
          _v45 = _v38.surface_box_dims
          _x = _v45
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (_v38.ar_tag_id,) = _struct_I.unpack(str[start:end])
          _v46 = val2.control_strategy
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v46.type = str[start:end].decode('utf-8')
          else:
            _v46.type = str[start:end]
          _x = _v46
          start = end
          end += 16
          (_x.max_speed, _x.max_force,) = _struct_2d.unpack(str[start:end])
          _v47 = _v46.orientation_constraint
          _v48 = _v47.header
          start = end
          end += 4
          (_v48.seq,) = _struct_I.unpack(str[start:end])
          _v49 = _v48.stamp
          _x = _v49
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v48.frame_id = str[start:end].decode('utf-8')
          else:
            _v48.frame_id = str[start:end]
          _v50 = _v47.orientation
          _x = _v50
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v47.link_name = str[start:end].decode('utf-8')
          else:
            _v47.link_name = str[start:end]
          _x = _v47
          start = end
          end += 32
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.custom_landmark_name = str[start:end].decode('utf-8')
          else:
            val2.custom_landmark_name = str[start:end]
          val1.actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.scene_id = str[start:end].decode('utf-8')
        else:
          val1.scene_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.landmarks = []
        for i in range(0, length):
          val2 = rapid_pbd_msgs.msg.Landmark()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          _v51 = val2.pose_stamped
          _v52 = _v51.header
          start = end
          end += 4
          (_v52.seq,) = _struct_I.unpack(str[start:end])
          _v53 = _v52.stamp
          _x = _v53
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v52.frame_id = str[start:end].decode('utf-8')
          else:
            _v52.frame_id = str[start:end]
          _v54 = _v51.pose
          _v55 = _v54.position
          _x = _v55
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v56 = _v54.orientation
          _x = _v56
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _v57 = val2.surface_box_dims
          _x = _v57
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (val2.ar_tag_id,) = _struct_I.unpack(str[start:end])
          val1.landmarks.append(val2)
        self.program.steps.append(val1)
      _x = self
      start = end
      end += 12
      (_x.program.start_joint_state.header.seq, _x.program.start_joint_state.header.stamp.secs, _x.program.start_joint_state.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program.start_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.program.start_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.program.start_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.program.start_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (self.step_num,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.type = str[start:end].decode('utf-8')
      else:
        self.action.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.actuator_group = str[start:end].decode('utf-8')
      else:
        self.action.actuator_group = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.gripper_command.position, _x.action.gripper_command.max_effort, _x.action.joint_trajectory.header.seq, _x.action.joint_trajectory.header.stamp.secs, _x.action.joint_trajectory.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.joint_trajectory.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.joint_trajectory.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action.joint_trajectory.joint_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.action.joint_trajectory.joint_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action.joint_trajectory.points = []
      for i in range(0, length):
        val1 = trajectory_msgs.msg.JointTrajectoryPoint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.positions = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.accelerations = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = struct.unpack(pattern, str[start:end])
        _v58 = val1.time_from_start
        _x = _v58
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.action.joint_trajectory.points.append(val1)
      _x = self
      start = end
      end += 56
      (_x.action.pose.position.x, _x.action.pose.position.y, _x.action.pose.position.z, _x.action.pose.orientation.x, _x.action.pose.orientation.y, _x.action.pose.orientation.z, _x.action.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.type = str[start:end].decode('utf-8')
      else:
        self.action.landmark.type = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action.landmark.pose_stamped.header.seq, _x.action.landmark.pose_stamped.header.stamp.secs, _x.action.landmark.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.landmark.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action.landmark.pose_stamped.pose.position.x, _x.action.landmark.pose_stamped.pose.position.y, _x.action.landmark.pose_stamped.pose.position.z, _x.action.landmark.pose_stamped.pose.orientation.x, _x.action.landmark.pose_stamped.pose.orientation.y, _x.action.landmark.pose_stamped.pose.orientation.z, _x.action.landmark.pose_stamped.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.name = str[start:end].decode('utf-8')
      else:
        self.action.landmark.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.landmark.surface_box_dims.x, _x.action.landmark.surface_box_dims.y, _x.action.landmark.surface_box_dims.z, _x.action.landmark.ar_tag_id,) = _struct_3dI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.type = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.control_strategy.max_speed, _x.action.control_strategy.max_force, _x.action.control_strategy.orientation_constraint.header.seq, _x.action.control_strategy.orientation_constraint.header.stamp.secs, _x.action.control_strategy.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.action.control_strategy.orientation_constraint.orientation.x, _x.action.control_strategy.orientation_constraint.orientation.y, _x.action.control_strategy.orientation_constraint.orientation.z, _x.action.control_strategy.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.action.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.action.control_strategy.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.custom_landmark_name = str[start:end].decode('utf-8')
      else:
        self.action.custom_landmark_name = str[start:end]
      start = end
      end += 4
      (self.action_num,) = _struct_i.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program_info.db_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program_info.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.program.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.program.steps)
      buff.write(_struct_I.pack(length))
      for val1 in self.program.steps:
        length = len(val1.actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.actions:
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.actuator_group
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v59 = val2.gripper_command
          _x = _v59
          buff.write(_struct_2d.pack(_x.position, _x.max_effort))
          _v60 = val2.joint_trajectory
          _v61 = _v60.header
          buff.write(_struct_I.pack(_v61.seq))
          _v62 = _v61.stamp
          _x = _v62
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v61.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v60.joint_names)
          buff.write(_struct_I.pack(length))
          for val4 in _v60.joint_names:
            length = len(val4)
            if python3 or type(val4) == unicode:
              val4 = val4.encode('utf-8')
              length = len(val4)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val4))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val4))
          length = len(_v60.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v60.points:
            length = len(val4.positions)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.positions.tostring())
            length = len(val4.velocities)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.velocities.tostring())
            length = len(val4.accelerations)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.accelerations.tostring())
            length = len(val4.effort)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.effort.tostring())
            _v63 = val4.time_from_start
            _x = _v63
            buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
          _v64 = val2.pose
          _v65 = _v64.position
          _x = _v65
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v66 = _v64.orientation
          _x = _v66
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v67 = val2.landmark
          _x = _v67.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v68 = _v67.pose_stamped
          _v69 = _v68.header
          buff.write(_struct_I.pack(_v69.seq))
          _v70 = _v69.stamp
          _x = _v70
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v69.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v71 = _v68.pose
          _v72 = _v71.position
          _x = _v72
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v73 = _v71.orientation
          _x = _v73
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = _v67.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v74 = _v67.surface_box_dims
          _x = _v74
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_I.pack(_v67.ar_tag_id))
          _v75 = val2.control_strategy
          _x = _v75.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v75
          buff.write(_struct_2d.pack(_x.max_speed, _x.max_force))
          _v76 = _v75.orientation_constraint
          _v77 = _v76.header
          buff.write(_struct_I.pack(_v77.seq))
          _v78 = _v77.stamp
          _x = _v78
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v77.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v79 = _v76.orientation
          _x = _v79
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = _v76.link_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v76
          buff.write(_struct_4d.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
          _x = val2.custom_landmark_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.scene_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.landmarks)
        buff.write(_struct_I.pack(length))
        for val2 in val1.landmarks:
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v80 = val2.pose_stamped
          _v81 = _v80.header
          buff.write(_struct_I.pack(_v81.seq))
          _v82 = _v81.stamp
          _x = _v82
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v81.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v83 = _v80.pose
          _v84 = _v83.position
          _x = _v84
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v85 = _v83.orientation
          _x = _v85
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v86 = val2.surface_box_dims
          _x = _v86
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_I.pack(val2.ar_tag_id))
      _x = self
      buff.write(_struct_3I.pack(_x.program.start_joint_state.header.seq, _x.program.start_joint_state.header.stamp.secs, _x.program.start_joint_state.header.stamp.nsecs))
      _x = self.program.start_joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.program.start_joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.program.start_joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.program.start_joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.program.start_joint_state.position.tostring())
      length = len(self.program.start_joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.program.start_joint_state.velocity.tostring())
      length = len(self.program.start_joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.program.start_joint_state.effort.tostring())
      buff.write(_struct_i.pack(self.step_num))
      _x = self.action.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action.actuator_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.action.gripper_command.position, _x.action.gripper_command.max_effort, _x.action.joint_trajectory.header.seq, _x.action.joint_trajectory.header.stamp.secs, _x.action.joint_trajectory.header.stamp.nsecs))
      _x = self.action.joint_trajectory.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action.joint_trajectory.joint_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.action.joint_trajectory.joint_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.action.joint_trajectory.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.action.joint_trajectory.points:
        length = len(val1.positions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.positions.tostring())
        length = len(val1.velocities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.velocities.tostring())
        length = len(val1.accelerations)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.accelerations.tostring())
        length = len(val1.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.effort.tostring())
        _v87 = val1.time_from_start
        _x = _v87
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      _x = self
      buff.write(_struct_7d.pack(_x.action.pose.position.x, _x.action.pose.position.y, _x.action.pose.position.z, _x.action.pose.orientation.x, _x.action.pose.orientation.y, _x.action.pose.orientation.z, _x.action.pose.orientation.w))
      _x = self.action.landmark.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action.landmark.pose_stamped.header.seq, _x.action.landmark.pose_stamped.header.stamp.secs, _x.action.landmark.pose_stamped.header.stamp.nsecs))
      _x = self.action.landmark.pose_stamped.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.action.landmark.pose_stamped.pose.position.x, _x.action.landmark.pose_stamped.pose.position.y, _x.action.landmark.pose_stamped.pose.position.z, _x.action.landmark.pose_stamped.pose.orientation.x, _x.action.landmark.pose_stamped.pose.orientation.y, _x.action.landmark.pose_stamped.pose.orientation.z, _x.action.landmark.pose_stamped.pose.orientation.w))
      _x = self.action.landmark.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3dI.pack(_x.action.landmark.surface_box_dims.x, _x.action.landmark.surface_box_dims.y, _x.action.landmark.surface_box_dims.z, _x.action.landmark.ar_tag_id))
      _x = self.action.control_strategy.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.action.control_strategy.max_speed, _x.action.control_strategy.max_force, _x.action.control_strategy.orientation_constraint.header.seq, _x.action.control_strategy.orientation_constraint.header.stamp.secs, _x.action.control_strategy.orientation_constraint.header.stamp.nsecs))
      _x = self.action.control_strategy.orientation_constraint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.action.control_strategy.orientation_constraint.orientation.x, _x.action.control_strategy.orientation_constraint.orientation.y, _x.action.control_strategy.orientation_constraint.orientation.z, _x.action.control_strategy.orientation_constraint.orientation.w))
      _x = self.action.control_strategy.orientation_constraint.link_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.action.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.action.control_strategy.orientation_constraint.weight))
      _x = self.action.custom_landmark_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_i.pack(self.action_num))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.program_info is None:
        self.program_info = rapid_pbd_msgs.msg.ProgramInfo()
      if self.program is None:
        self.program = rapid_pbd_msgs.msg.Program()
      if self.action is None:
        self.action = rapid_pbd_msgs.msg.Action()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8')
      else:
        self.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program_info.db_id = str[start:end].decode('utf-8')
      else:
        self.program_info.db_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program_info.name = str[start:end].decode('utf-8')
      else:
        self.program_info.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program.name = str[start:end].decode('utf-8')
      else:
        self.program.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.program.steps = []
      for i in range(0, length):
        val1 = rapid_pbd_msgs.msg.Step()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.actions = []
        for i in range(0, length):
          val2 = rapid_pbd_msgs.msg.Action()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.actuator_group = str[start:end].decode('utf-8')
          else:
            val2.actuator_group = str[start:end]
          _v88 = val2.gripper_command
          _x = _v88
          start = end
          end += 16
          (_x.position, _x.max_effort,) = _struct_2d.unpack(str[start:end])
          _v89 = val2.joint_trajectory
          _v90 = _v89.header
          start = end
          end += 4
          (_v90.seq,) = _struct_I.unpack(str[start:end])
          _v91 = _v90.stamp
          _x = _v91
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v90.frame_id = str[start:end].decode('utf-8')
          else:
            _v90.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v89.joint_names = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4 = str[start:end].decode('utf-8')
            else:
              val4 = str[start:end]
            _v89.joint_names.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v89.points = []
          for i in range(0, length):
            val4 = trajectory_msgs.msg.JointTrajectoryPoint()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.positions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.velocities = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.accelerations = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            _v92 = val4.time_from_start
            _x = _v92
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
            _v89.points.append(val4)
          _v93 = val2.pose
          _v94 = _v93.position
          _x = _v94
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v95 = _v93.orientation
          _x = _v95
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v96 = val2.landmark
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v96.type = str[start:end].decode('utf-8')
          else:
            _v96.type = str[start:end]
          _v97 = _v96.pose_stamped
          _v98 = _v97.header
          start = end
          end += 4
          (_v98.seq,) = _struct_I.unpack(str[start:end])
          _v99 = _v98.stamp
          _x = _v99
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v98.frame_id = str[start:end].decode('utf-8')
          else:
            _v98.frame_id = str[start:end]
          _v100 = _v97.pose
          _v101 = _v100.position
          _x = _v101
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v102 = _v100.orientation
          _x = _v102
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v96.name = str[start:end].decode('utf-8')
          else:
            _v96.name = str[start:end]
          _v103 = _v96.surface_box_dims
          _x = _v103
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (_v96.ar_tag_id,) = _struct_I.unpack(str[start:end])
          _v104 = val2.control_strategy
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v104.type = str[start:end].decode('utf-8')
          else:
            _v104.type = str[start:end]
          _x = _v104
          start = end
          end += 16
          (_x.max_speed, _x.max_force,) = _struct_2d.unpack(str[start:end])
          _v105 = _v104.orientation_constraint
          _v106 = _v105.header
          start = end
          end += 4
          (_v106.seq,) = _struct_I.unpack(str[start:end])
          _v107 = _v106.stamp
          _x = _v107
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v106.frame_id = str[start:end].decode('utf-8')
          else:
            _v106.frame_id = str[start:end]
          _v108 = _v105.orientation
          _x = _v108
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v105.link_name = str[start:end].decode('utf-8')
          else:
            _v105.link_name = str[start:end]
          _x = _v105
          start = end
          end += 32
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.custom_landmark_name = str[start:end].decode('utf-8')
          else:
            val2.custom_landmark_name = str[start:end]
          val1.actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.scene_id = str[start:end].decode('utf-8')
        else:
          val1.scene_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.landmarks = []
        for i in range(0, length):
          val2 = rapid_pbd_msgs.msg.Landmark()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          _v109 = val2.pose_stamped
          _v110 = _v109.header
          start = end
          end += 4
          (_v110.seq,) = _struct_I.unpack(str[start:end])
          _v111 = _v110.stamp
          _x = _v111
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v110.frame_id = str[start:end].decode('utf-8')
          else:
            _v110.frame_id = str[start:end]
          _v112 = _v109.pose
          _v113 = _v112.position
          _x = _v113
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v114 = _v112.orientation
          _x = _v114
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _v115 = val2.surface_box_dims
          _x = _v115
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (val2.ar_tag_id,) = _struct_I.unpack(str[start:end])
          val1.landmarks.append(val2)
        self.program.steps.append(val1)
      _x = self
      start = end
      end += 12
      (_x.program.start_joint_state.header.seq, _x.program.start_joint_state.header.stamp.secs, _x.program.start_joint_state.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.program.start_joint_state.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.program.start_joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.program.start_joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.program.start_joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.program.start_joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (self.step_num,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.type = str[start:end].decode('utf-8')
      else:
        self.action.type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.actuator_group = str[start:end].decode('utf-8')
      else:
        self.action.actuator_group = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.gripper_command.position, _x.action.gripper_command.max_effort, _x.action.joint_trajectory.header.seq, _x.action.joint_trajectory.header.stamp.secs, _x.action.joint_trajectory.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.joint_trajectory.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.joint_trajectory.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action.joint_trajectory.joint_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.action.joint_trajectory.joint_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action.joint_trajectory.points = []
      for i in range(0, length):
        val1 = trajectory_msgs.msg.JointTrajectoryPoint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.positions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocities = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.accelerations = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v116 = val1.time_from_start
        _x = _v116
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.action.joint_trajectory.points.append(val1)
      _x = self
      start = end
      end += 56
      (_x.action.pose.position.x, _x.action.pose.position.y, _x.action.pose.position.z, _x.action.pose.orientation.x, _x.action.pose.orientation.y, _x.action.pose.orientation.z, _x.action.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.type = str[start:end].decode('utf-8')
      else:
        self.action.landmark.type = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action.landmark.pose_stamped.header.seq, _x.action.landmark.pose_stamped.header.stamp.secs, _x.action.landmark.pose_stamped.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.pose_stamped.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.landmark.pose_stamped.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action.landmark.pose_stamped.pose.position.x, _x.action.landmark.pose_stamped.pose.position.y, _x.action.landmark.pose_stamped.pose.position.z, _x.action.landmark.pose_stamped.pose.orientation.x, _x.action.landmark.pose_stamped.pose.orientation.y, _x.action.landmark.pose_stamped.pose.orientation.z, _x.action.landmark.pose_stamped.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.landmark.name = str[start:end].decode('utf-8')
      else:
        self.action.landmark.name = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.landmark.surface_box_dims.x, _x.action.landmark.surface_box_dims.y, _x.action.landmark.surface_box_dims.z, _x.action.landmark.ar_tag_id,) = _struct_3dI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.type = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.type = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action.control_strategy.max_speed, _x.action.control_strategy.max_force, _x.action.control_strategy.orientation_constraint.header.seq, _x.action.control_strategy.orientation_constraint.header.stamp.secs, _x.action.control_strategy.orientation_constraint.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.orientation_constraint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.orientation_constraint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.action.control_strategy.orientation_constraint.orientation.x, _x.action.control_strategy.orientation_constraint.orientation.y, _x.action.control_strategy.orientation_constraint.orientation.z, _x.action.control_strategy.orientation_constraint.orientation.w,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.control_strategy.orientation_constraint.link_name = str[start:end].decode('utf-8')
      else:
        self.action.control_strategy.orientation_constraint.link_name = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.action.control_strategy.orientation_constraint.absolute_x_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_y_axis_tolerance, _x.action.control_strategy.orientation_constraint.absolute_z_axis_tolerance, _x.action.control_strategy.orientation_constraint.weight,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action.custom_landmark_name = str[start:end].decode('utf-8')
      else:
        self.action.custom_landmark_name = str[start:end]
      start = end
      end += 4
      (self.action_num,) = _struct_i.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d3I = struct.Struct("<2d3I")
_struct_7d = struct.Struct("<7d")
_struct_3dI = struct.Struct("<3dI")
_struct_2i = struct.Struct("<2i")
_struct_2d = struct.Struct("<2d")
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
